diff --git a/libglusterfs/src/glusterfs/syscall.h b/libglusterfs/src/glusterfs/syscall.h
index 91e921aea50..9a9059463b3 100644
--- a/libglusterfs/src/glusterfs/syscall.h
+++ b/libglusterfs/src/glusterfs/syscall.h
@@ -122,6 +122,9 @@ sys_chmod(const char *path, mode_t mode);
 int
 sys_fchmod(int fd, mode_t mode);
 
+int
+sys_lchmod(const char *path, mode_t mode);
+
 int
 sys_chown(const char *path, uid_t owner, gid_t group);
 
diff --git a/libglusterfs/src/libglusterfs.sym b/libglusterfs/src/libglusterfs.sym
index c3915921919..cb03dc23a93 100644
--- a/libglusterfs/src/libglusterfs.sym
+++ b/libglusterfs/src/libglusterfs.sym
@@ -1045,6 +1045,7 @@ sys_fstatat
 sys_fsync
 sys_ftruncate
 sys_futimes
+sys_lchmod
 sys_lchown
 sys_lgetxattr
 sys_link
diff --git a/libglusterfs/src/syscall.c b/libglusterfs/src/syscall.c
index 007e3e84eea..c6fceb5b856 100644
--- a/libglusterfs/src/syscall.c
+++ b/libglusterfs/src/syscall.c
@@ -285,6 +285,12 @@ sys_fchmod(int fd, mode_t mode)
     return FS_RET_CHECK0(fchmod(fd, mode), errno);
 }
 
+int
+sys_lchmod(const char *path, mode_t mode)
+{
+    return FS_RET_CHECK0(lchmod(path, mode), errno);
+}
+
 int
 sys_chown(const char *path, uid_t owner, gid_t group)
 {
diff --git a/xlators/storage/posix/src/posix-inode-fd-ops.c b/xlators/storage/posix/src/posix-inode-fd-ops.c
index 6deba49aba9..ada7595970b 100644
--- a/xlators/storage/posix/src/posix-inode-fd-ops.c
+++ b/xlators/storage/posix/src/posix-inode-fd-ops.c
@@ -250,11 +250,15 @@ posix_do_chmod(xlator_t *this, const char *path, struct iatt *stbuf)
         mode_bit = (mode & priv->create_mask) | priv->force_create_mode;
         mode = posix_override_umask(mode, mode_bit);
     }
-    ret = lchmod(path, mode);
-    if ((ret == -1) && (errno == ENOSYS)) {
-        /* in Linux symlinks are always in mode 0777 and no
-           such call as lchmod exists.
-        */
+    ret = sys_lchmod(path, mode);
+    /* Before glibc 2.32, lchmod() was not implemented and calling it
+     * always returned ENOSYS. Starting with glibc 2.32 this request
+     * is using fchmodat() system call to implement it. However, linux
+     * doesn't support setting the mode for symlinks, so the system
+     * call returns EOPNOTSUPP (or ENOTSUP based on man page). We need
+     * to handle all cases. */
+    if ((ret < 0) &&
+        ((errno == ENOSYS) || (errno == EOPNOTSUPP) || (errno == ENOTSUP))) {
         gf_msg_debug(this->name, 0, "%s (%s)", path, strerror(errno));
         if (is_symlink) {
             ret = 0;
